Package: org.apache.groovy.contracts.generation

## [Java] Class AssertStatementCreationUtility.ReturnStatementVisitor

- org.apache.groovy.contracts.generation.AssertStatementCreationUtility.ReturnStatementVisitor

-     public static class AssertStatementCreationUtility.ReturnStatementVisitor
      extends ClassCodeVisitorSupport

  Collects all ReturnStatement instances from a given code block.

- - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `public List<ReturnStatement>` | `getReturnStatements()` Returns the collected return statements.
    `` | `protected SourceUnit` | `getSourceUnit()` This visitor is source-independent.
    `` | `public void` | `visitClosureExpression(ClosureExpression expression)` Skips nested closures so only returns from the surrounding method are collected.
    `` | `public void` | `visitReturnStatement(ReturnStatement statement)` Records one visited return statement.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class ClassCodeVisitorSupport` | `addError, getSourceUnit, visitAnnotation, visitAnnotations, visitAnnotations, visitAssertStatement, visitBlockStatement, visitBreakStatement, visitCaseStatement, visitCatchStatement, visitClass, visitClassCodeContainer, visitClosureExpression, visitConstructor, visitConstructorOrMethod, visitContinueStatement, visitDeclarationExpression, visitDoWhileLoop, visitExpressionStatement, visitField, visitForLoop, visitIfElse, visitImports, visitMethod, visitObjectInitializerStatements, visitPackage, visitProperty, visitReturnStatement, visitStatement, visitStatementAnnotations, visitSwitch, visitSynchronizedStatement, visitThrowStatement, visitTryCatchFinally, visitWhileLoop, visitYieldStatement`
    `class CodeVisitorSupport` | `afterSwitchCaseStatementsVisited, afterSwitchCaseStatementsVisited, afterSwitchConditionExpressionVisited, afterSwitchConditionExpressionVisited, visitArgumentlistExpression, visitArrayExpression, visitAssertStatement, visitAttributeExpression, visitBinaryExpression, visitBitwiseNegationExpression, visitBlockStatement, visitBooleanExpression, visitBreakStatement, visitBytecodeExpression, visitCaseStatement, visitCastExpression, visitCatchStatement, visitClassExpression, visitClosureExpression, visitClosureListExpression, visitConstantExpression, visitConstructorCallExpression, visitContinueStatement, visitDeclarationExpression, visitDoWhileLoop, visitEmptyStatement, visitExpressionStatement, visitFieldExpression, visitForLoop, visitGStringExpression, visitIfElse, visitLambdaExpression, visitListExpression, visitMapEntryExpression, visitMapExpression, visitMethodCallExpression, visitMethodPointerExpression, visitMethodReferenceExpression, visitNotExpression, visitPostfixExpression, visitPrefixExpression, visitPropertyExpression, visitRangeExpression, visitReturnStatement, visitShortTernaryExpression, visitSpreadExpression, visitSpreadMapExpression, visitStaticMethodCallExpression, visitSwitch, visitSwitchExpression, visitSynchronizedStatement, visitTernaryExpression, visitThrowStatement, visitTryCatchFinally, visitTupleExpression, visitUnaryMinusExpression, visitUnaryPlusExpression, visitVariableExpression, visitWhileLoop, visitYieldStatement`

- - ### Method Detail

    - #### public List<ReturnStatement> getReturnStatements()

      Returns the collected return statements.

      Returns:
        the collected return statements

    - #### protected SourceUnit getSourceUnit()

      This visitor is source-independent.

      Returns:
        `null`

    - #### public void visitClosureExpression(ClosureExpression expression)

      Skips nested closures so only returns from the surrounding method are collected.

      Parameters:
        `expression` - the closure expression to ignore

    - #### public void visitReturnStatement(ReturnStatement statement)

      Records one visited return statement.

      Parameters:
        `statement` - the return statement to collect